<?php
header("Content-Type: text/html;charset=utf-8");

class cls_Igv {

	private $db_nombretabla = "igv";
	private $db_nombrevista = "igv";
	private $db_filas = "*";
	private $igv_id = 0;
	private $nombre = "";
	private $porcentaje = "";
	private $estado = false;
	private $usuario_modificacion = 0;
	private $fecha_creacion = "";
	private $fecha_modificacion = "";
	private $activo = true;
	
	public function __construct(){
		$this->db_filas = "igv_id, nombre, porcentaje, estado, usuario_modificacion, fecha_creacion, fecha_modificacion, activo";
	}

	static public function Indice($codigo){
		$current = new cls_Igv();
		$conn = new cls_Conexion();
		$filtro = "igv_id = ?";
		$values = array();
		array_push($values, $codigo );
		$lista = $conn->buscar_datos($current->db_nombrevista, $current->db_filas, $filtro, $values, "");
		$current->db_mensaje = $conn->getMensaje();
		for ($indice=0; $indice<count($lista); $indice++){
			$current->igv_id = $lista[$indice]["igv_id"];
			$current->nombre = $lista[$indice]["nombre"];
			$current->porcentaje = $lista[$indice]["porcentaje"];
			$current->estado = $lista[$indice]["estado"];
			$current->usuario_modificacion = $lista[$indice]["usuario_modificacion"];
			$current->fecha_creacion = $lista[$indice]["fecha_creacion"];
			$current->fecha_modificacion = $lista[$indice]["fecha_modificacion"];
			$current->activo = $lista[$indice]["activo"];
		}
		return $current;
	}

	public function get_igv_id() { return $this->igv_id; }
	public function get_nombre() { return $this->nombre; }
	public function get_porcentaje() { return $this->porcentaje; }
	public function get_estado() { return $this->estado; }
	public function get_usuario_modificacion(){  return $this->usuario_modificacion; }
	public function get_fecha_creacion(){  return $this->fecha_creacion; }
	public function get_fecha_modificacion(){  return $this->fecha_modificacion; }
	public function get_activo() { return $this->activo; }
	
	public function set_igv_id($igv_id){ $this->igv_id = $igv_id; }
	public function set_nombre($nombre){ $this->nombre = $nombre; }
	public function set_porcentaje($porcentaje){ $this->porcentaje = $porcentaje; }
	public function set_estado($estado){ $this->estado = $estado; }
	public function set_usuario_modificacion($usuario_modificacion){ $this->usuario_modificacion = $usuario_modificacion; }
	public function set_fecha_creacion($fecha_creacion){ $this->fecha_creacion = $fecha_creacion; }
	public function set_fecha_modificacion($fecha_modificacion){ $this->fecha_modificacion = $fecha_modificacion; }
	public function set_activo($activo){ $this->activo = $activo; }
	
	public function registrar( $usuario_editor ){
		$conn = new cls_Conexion();
		$respuesta = false;
		$values = array();
		if ( $this->igv_id == 0 ){ // REGISTER
			array_push($values, $this->nombre);
			array_push($values, $this->porcentaje);
			array_push($values, $this->estado);
			array_push($values, $usuario_editor);
			$respuesta = $conn->nuevo_registro($this->db_nombretabla, $values);
			$this->db_mensaje = $conn->GetMensaje();
			if ( $respuesta ){
				$this->igv_id = $conn->getlastId();
			}
		} else { // UPDATE
			array_push($values, $this->nombre);
			array_push($values, $this->porcentaje);
			array_push($values, $this->estado);
			array_push($values, $usuario_editor);
			array_push($values, $this->igv_id);
			$respuesta = $conn->editar_registro($this->db_nombretabla, $values);
			$this->db_mensaje = $conn->GetMensaje();
		}
		return $respuesta;
	}
	
	public function importar( $usuario_editor ){
		$conn = new cls_Conexion();
		$respuesta = false;
		$values = array();
			array_push($values, $this->igv_id);
			array_push($values, $this->nombre);
			array_push($values, $this->porcentaje);
			array_push($values, $this->estado);
			array_push($values, $this->usuario_modificacion);
			array_push($values, $this->fecha_creacion);
			array_push($values, $this->fecha_modificacion);
			array_push($values, $this->activo);
			
			array_push($values, $this->nombre);
			array_push($values, $this->porcentaje);
			array_push($values, $this->estado);
			array_push($values, $this->usuario_modificacion);
			array_push($values, $this->fecha_creacion);
			array_push($values, $this->fecha_modificacion);
			array_push($values, $this->activo);
		$respuesta = $conn->importar_registro($this->db_nombretabla, $values);
		$this->db_mensaje = $conn->GetMensaje();
		if ( $respuesta ){
			$this->igv_id = $conn->getlastId();
		};
		return $respuesta;
	}

	public function eliminar( $usuario_editor ){
		$conn = new cls_Conexion();
		$respuesta = false;
		$values = array();
		if ($this->igv_id > 0){ // DELETE
			array_push($values, $usuario_editor);
			array_push($values, $this->igv_id );
			$respuesta = $conn->eliminar_registro($this->db_nombretabla, $values);
			$this->db_mensaje = $conn->GetMensaje();
		} else {
			$this->db_mensaje = "No se puede realizar este proceso";
		}
		return $respuesta;
	}
}

class cls_Group_Igv {

	protected $db_mensaje = "";
	protected $db_nombre_tabla = "igv";
	protected $db_nombres_columnas = "*";
	protected $db_filtro = "1";
	protected $db_agrupar = "";
	protected $db_orden_columna = "nombre";
	protected $db_orden_direccion = "ASC";
	protected $db_cantidad = 0;
	protected $db_filtro_datos = array();
	protected $db_filas = array();
	
	public function __construct(){
		$this->db_nombres_columnas = "igv_id, nombre, porcentaje, estado, usuario_modificacion, fecha_creacion, fecha_modificacion, activo";
		$this->db_orden_columna = "nombre";
	}

	static public function Buscar($buscar="", $ordendireccion="ASC", $ordencolumna="nombre", $agrupar=""){
		$conn = new cls_Conexion();
		$current = new cls_Group_Igv();
		$buscar = "%".$buscar."%";
		$current->db_filtro = "nombre LIKE ? AND activo = true";
		$current->db_orden_columna = $ordencolumna;
		$current->db_orden_direccion = $ordendireccion;
		$current->db_agrupar = $agrupar;
		array_push($current->db_filtro_datos, $buscar );
		$current->db_cantidad = $conn->contar_filas( $current->db_nombre_tabla, $current->db_filtro, $current->db_filtro_datos, $current->db_agrupar );
		$current->db_mensaje = $conn->getMensaje();
		return $current;
	}
	public function cargar_datos( $offset, $cantidad ){
		$conn = new cls_Conexion();
		$this->db_filas = $conn->listar_filas( $this->db_nombre_tabla, $this->db_nombres_columnas, $this->db_orden_columna, $this->db_orden_direccion, $this->db_filtro, $this->db_filtro_datos, $offset, $cantidad, $this->db_agrupar );
		$this->db_mensaje = $conn->GetMensaje();
	}
	public function get_cantidad_cargados(){
		return count($this->db_filas);
	}
	public function get_cantidad(){
		return $this->db_cantidad;
	}
	
	public function get_igv_id($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["igv_id"];
			return $val;
		}
		return 0;
	}
	public function get_nombre($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["nombre"];
			return $val;
		}
		return "";
	}
	public function get_porcentaje($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["porcentaje"];
			return $val;
		}
		return "";
	}
	public function get_estado($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["estado"];
			return $val;
		}
		return false;
	}
	public function get_usuario_modificacion($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["usuario_modificacion"];
			return $val;
		}
		return 0;
	}
	public function get_fecha_creacion($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["fecha_creacion"];
			return $val;
		}
		return "";
	}
	public function get_fecha_modificacion($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["fecha_modificacion"];
			return $val;
		}
		return "";
	}
	public function get_activo($indice){
		if ($indice >= 0 && count($this->db_filas) > $indice){
			$val = $this->db_filas[$indice]["activo"];
			return $val;
		}
		return "";
	}
};
?>		
